<template>
  <div
    class="card"
    :class="editing ? 'orange' : ''"
    :id="id"
  >
    <div class="content">
      <div class="header">
        <div class="ui fluid input transparent">
          <input
            type="text"
            v-model="data_name"
            placeholder="Nom"
          >
        </div>
      </div>

      <div class="meta"></div>
      <div class="description">
        <div class="ui fluid input transparent">
          <input
            type="text"
            v-model="data_description"
            placeholder="Description"
          >
        </div>
      </div>
      <br/>

      <div class="ui small basic icon right floated buttons">
        <div
          class="ui button"
          @click="remove"
        >
          <i class="ui red trash icon"></i>
        </div>
        <div
          class="ui button"
          v-show="editing"
          @click="validateUpdate"
        >
          <i class="ui green save icon"></i>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import store from '@/store/Store'

export default {
  name: 'DietCard',
  store,
  props: {
    _id: String,
    name: String,
    description: String
  },
  data () {
    return {
      editing: false,
      hovered: false,
      data_name: this.name,
      data_description: this.description
    }
  },
  watch: {
    data_name () {
      this.editing = true
    },
    data_description () {
      this.editing = true
    }
  },
  methods: {
    remove () {
      this.$emit('removeDiet', this._id) // catché dans Diets.vue
    },
    validateUpdate () {
      let updatedDiet = {
        _id: this._id,
        name: this.data_name,
        description: this.data_description
      }

      store.dispatch('DietsStore/updateDiet', updatedDiet)
        .then((response) => {
          this.editing = false
          this.$toastr.s(updatedDiet.name + ' bien modifié')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    }
  },
  computed: {
    id () {
      return 'dietcard' + Math.floor(Math.random() * 100000)
    }
  }
}
</script>
